SFML - Simple and Fast Multimedia Library

SFML 3.1.0
Loading...
Searching...
No Matches
Classes | Public Types | Public Member Functions | Protected Member Functions | List of all members
sf::Music Class Reference
Audio module

Streamed music played from an audio file. More...

`#include <SFML/Audio/Music.hpp>`

Inheritance diagram for sf::Music:

## Classes
struct | Span
| Structure defining a time range using the template type. More...

## Public Types
using | TimeSpan = Span<Time>
enum class | Status { Stopped , Paused , Playing }
| Enumeration of the sound source states. More...
using | EffectProcessor
| Callable that is provided with sound data for processing.

## Public Member Functions
| Music ()
| Default constructor.
| Music (const std::filesystem::path &filename)
| Construct a music from an audio file.
| Music (const void *data, std::size_t sizeInBytes)
| Construct a music from an audio file in memory.
| Music (InputStream &stream)
| Construct a music from an audio file in a custom stream.
| ~Music () override
| Destructor.
| Music (Music &&) noexcept
| Move constructor.
Music & | operator= (Music &&) noexcept
| Move assignment.
bool | openFromFile (const std::filesystem::path &filename)
| Open a music from an audio file.
bool | openFromMemory (const void *data, std::size_t sizeInBytes)
| Open a music from an audio file in memory.
bool | openFromStream (InputStream &stream)
| Open a music from an audio file in a custom stream.
Time | getDuration () const
| Get the total duration of the music.
TimeSpan | getLoopPoints () const
| Get the positions of the of the sound's looping sequence.
void | setLoopPoints (TimeSpan timePoints)
| Sets the beginning and duration of the sound's looping sequence using sf::Time.
void | play () override
| Start or resume playing the audio stream.
void | pause () override
| Pause the audio stream.
void | stop () override
| Stop playing the audio stream.
unsigned int | getChannelCount () const
| Return the number of channels of the stream.
unsigned int | getSampleRate () const
| Get the stream sample rate of the stream.
const std::vector< SoundChannel > & | getChannelMap () const
| Get the map of position in sample frame to sound channel.
Status | getStatus () const override
| Get the current status of the stream (stopped, paused, playing).
void | setPlayingOffset (Time timeOffset)
| Change the current playing position of the stream.
Time | getPlayingOffset () const
| Get the current playing position of the stream.
void | setLooping (bool loop)
| Set whether or not the stream should loop after reaching the end.
bool | isLooping () const
| Tell whether or not the stream is in loop mode.
void | setEffectProcessor (EffectProcessor effectProcessor) override
| Set the effect processor to be applied to the sound.
void | setPitch (float pitch)
| Set the pitch of the sound.
void | setPan (float pan)
| Set the pan of the sound.
void | setVolume (float volume)
| Set the volume of the sound.
void | setSpatializationEnabled (bool enabled)
| Set whether spatialization of the sound is enabled.
void | setPosition (const Vector3f &position)
| Set the 3D position of the sound in the audio scene.
void | setDirection (const Vector3f &direction)
| Set the 3D direction of the sound in the audio scene.
void | setCone (const Cone &cone)
| Set the cone properties of the sound in the audio scene.
void | setVelocity (const Vector3f &velocity)
| Set the 3D velocity of the sound in the audio scene.
void | setDopplerFactor (float factor)
| Set the doppler factor of the sound.
void | setDirectionalAttenuationFactor (float factor)
| Set the directional attenuation factor of the sound.
void | setRelativeToListener (bool relative)
| Make the sound's position relative to the listener or absolute.
void | setMinDistance (float distance)
| Set the minimum distance of the sound.
void | setMaxDistance (float distance)
| Set the maximum distance of the sound.
void | setMinGain (float gain)
| Set the minimum gain of the sound.
void | setMaxGain (float gain)
| Set the maximum gain of the sound.
void | setAttenuation (float attenuation)
| Set the attenuation factor of the sound.
float | getPitch () const
| Get the pitch of the sound.
float | getPan () const
| Get the pan of the sound.
float | getVolume () const
| Get the volume of the sound.
bool | isSpatializationEnabled () const
| Tell whether spatialization of the sound is enabled.
Vector3f | getPosition () const
| Get the 3D position of the sound in the audio scene.
Vector3f | getDirection () const
| Get the 3D direction of the sound in the audio scene.
Cone | getCone () const
| Get the cone properties of the sound in the audio scene.
Vector3f | getVelocity () const
| Get the 3D velocity of the sound in the audio scene.
float | getDopplerFactor () const
| Get the doppler factor of the sound.
float | getDirectionalAttenuationFactor () const
| Get the directional attenuation factor of the sound.
bool | isRelativeToListener () const
| Tell whether the sound's position is relative to the listener or is absolute.
float | getMinDistance () const
| Get the minimum distance of the sound.
float | getMaxDistance () const
| Get the maximum distance of the sound.
float | getMinGain () const
| Get the minimum gain of the sound.
float | getMaxGain () const
| Get the maximum gain of the sound.
float | getAttenuation () const
| Get the attenuation factor of the sound.

## Protected Member Functions
bool | onGetData (Chunk &data) override
| Request a new chunk of audio samples from the stream source.
void | onSeek (Time timeOffset) override
| Change the current playing position in the stream source.
std::optional< std::uint64_t > | onLoop () override
| Change the current playing position in the stream source to the loop offset.
void | initialize (unsigned int channelCount, unsigned int sampleRate, const std::vector< SoundChannel > &channelMap)
| Define the audio stream parameters.

## Detailed Description

Streamed music played from an audio file.

Musics are sounds that are streamed rather than completely loaded in memory.

This is especially useful for compressed musics that usually take hundreds of MB when they are uncompressed: by streaming it instead of loading it entirely, you avoid saturating the memory and have almost no loading delay. This implies that the underlying resource (file, stream or memory buffer) must remain valid for the lifetime of the sf::Music object.

Apart from that, a sf::Music has almost the same features as the sf::SoundBuffer / sf::Sound pair: you can play/pause/stop it, request its parameters (channels, sample rate), change the way it is played (pitch, volume, 3D position, ...), etc.

As a sound stream, a music is played in its own thread in order not to block the rest of the program. This means that you can leave the music alone after calling play(), it will manage itself very well.

Usage example:

// Open a music from an audio file
sf::Music music("music.ogg");
// Change some parameters
music.setPosition({0, 1, 10}); // change its 3D position
music.setPitch(2); // increase the pitch
music.setVolume(50); // reduce the volume
music.setLooping(true); // make it loop
// Play it
music.play();
sf::Music
Streamed music played from an audio file.
Definition Music.hpp:53

See also
  sf::Sound, sf::SoundStream

Definition at line 52 of file Music.hpp.

## Member Typedef Documentation

## ◆ EffectProcessor

using sf::SoundSource::EffectProcessor
| inherited

Initial value:
std::function<
void(const float* inputFrames, unsigned int& inputFrameCount, float* outputFrames, unsigned int& outputFrameCount, unsigned int frameChannelCount)>

Callable that is provided with sound data for processing.

When the audio engine sources sound data from sound sources it will pass the data through an effects processor if one is set. The sound data will already be converted to the internal floating point format and have the same sample rate as the audio device and engine. The device sample rate can differ from the sample rate of the source data so keep this in mind when setting up processing that is dependent on the sample rate. The sample rate of the current playback device can be retrieved using sf::PlaybackDevice::getDeviceSampleRate().

Sound data that is processed this way is provided in frames. Each frame contains 1 floating point sample per channel. If e.g. the data source provides stereo data, each frame will contain 2 floats.

The effects processor function takes 4 parameters:

- The input data frames, channels interleaved
- The number of input data frames available
- The buffer to write output data frames to, channels interleaved
- The number of output data frames that the output buffer can hold
- The channel count

The input and output frame counts are in/out parameters.

When this function is called, the input count will contain the number of frames available in the input buffer. The output count will contain the size of the output buffer i.e. the maximum number of frames that can be written to the output buffer.

Attempting to read more frames than the input frame count or write more frames than the output frame count will result in undefined behaviour.

It is important to note that the channel count of the audio engine currently sourcing data from this sound will always be provided in frameChannelCount. This can be different from the channel count of the sound source so make sure to size necessary processing buffers according to the engine channel count and not the sound source channel count.

When done processing the frames, the input and output frame counts must be updated to reflect the actual number of frames that were read from the input and written to the output.

The processing function should always try to process as much sound data as possible i.e. always try to fill the output buffer to the maximum. In certain situations for specific effects it can be possible that the input frame count and output frame count aren't equal. As long as the frame counts are updated accordingly this is perfectly valid.

If the audio engine determines that no audio data is available from the data source, the input data frames pointer is set to nullptr and the input frame count is set to 0. In this case it is up to the function to decide how to handle the situation. For specific effects e.g. Echo/Delay buffered data might still be able to be written to the output buffer even if there is no longer any input data.

An important thing to remember is that this function is directly called by the audio engine. Because the audio engine runs on an internal thread of its own, make sure access to shared data is synchronized appropriately.

Because this function is stored by the SoundSource object it will be able to be called as long as the SoundSource object hasn't yet been destroyed. Make sure that any data this function references outlives the SoundSource object otherwise use-after-free errors will occur.

Definition at line 160 of file SoundSource.hpp.

## ◆ TimeSpan

using sf::Music::TimeSpan = Span<Time>

Definition at line 67 of file Music.hpp.

## Member Enumeration Documentation

## ◆ Status

enum class sf::SoundSource::Status
| stronginherited

Enumeration of the sound source states.

Enumerator
Stopped | Sound is not playing.
Paused | Sound is paused.
Playing | Sound is playing.

Definition at line 54 of file SoundSource.hpp.

## Constructor & Destructor Documentation

## ◆ Music() [1/5]

sf::Music::Music | ( |  | ) |

Default constructor.

Construct an empty music that does not contain any data.

## ◆ Music() [2/5]

sf::Music::Music | ( | const std::filesystem::path & | filename | ) |
| explicit

Construct a music from an audio file.

This function doesn't start playing the music (call play() to do so). See the documentation of sf::InputSoundFile for the list of supported formats.

Warning
  Since the music is not loaded at once but rather streamed continuously, the file must remain accessible until the sf::Music object loads a new music or is destroyed.

Parameters

  filename | Path of the music file to open

Exceptions

  sf::Exception | if loading was unsuccessful

See also
  openFromMemory, openFromStream

## ◆ Music() [3/5]

sf::Music::Music | ( | const void * | data,
|  | std::size_t | sizeInBytes )

Construct a music from an audio file in memory.

This function doesn't start playing the music (call play() to do so). See the documentation of sf::InputSoundFile for the list of supported formats.

Warning
  Since the music is not loaded at once but rather streamed continuously, the data buffer must remain accessible until the sf::Music object loads a new music or is destroyed. That is, you can't deallocate the buffer right after calling this function.

Parameters

  data | Pointer to the file data in memory
  sizeInBytes | Size of the data to load, in bytes

Exceptions

  sf::Exception | if loading was unsuccessful

See also
  openFromFile, openFromStream

## ◆ Music() [4/5]

sf::Music::Music | ( | InputStream & | stream | ) |
| explicit

Construct a music from an audio file in a custom stream.

This function doesn't start playing the music (call play() to do so). See the documentation of sf::InputSoundFile for the list of supported formats.

Warning
  Since the music is not loaded at once but rather streamed continuously, the stream must remain accessible until the sf::Music object loads a new music or is destroyed.

Parameters

  stream | Source stream to read from

Exceptions

  sf::Exception | if loading was unsuccessful

See also
  openFromFile, openFromMemory

## ◆ ~Music()

sf::Music::~Music | ( |  | ) |
| override

Destructor.

## ◆ Music() [5/5]

sf::Music::Music | ( | Music && |  | ) |
| noexcept

Move constructor.

## Member Function Documentation

## ◆ getAttenuation()

float sf::SoundSource::getAttenuation | ( |  | ) | const
| nodiscardinherited

Get the attenuation factor of the sound.

Returns
  Attenuation factor of the sound

See also
  setAttenuation, getMinDistance

## ◆ getChannelCount()

unsigned int sf::SoundStream::getChannelCount | ( |  | ) | const
| nodiscardinherited

Return the number of channels of the stream.

1 channel means a mono sound, 2 means stereo, etc.

Returns
  Number of channels

## ◆ getChannelMap()

const std::vector< SoundChannel > & sf::SoundStream::getChannelMap | ( |  | ) | const
| nodiscardinherited

Get the map of position in sample frame to sound channel.

This is used to map a sample in the sample stream to a position during spatialization.

Returns
  Map of position in sample frame to sound channel

## ◆ getCone()

Cone sf::SoundSource::getCone | ( |  | ) | const
| nodiscardinherited

Get the cone properties of the sound in the audio scene.

Returns
  Cone properties of the sound

See also
  setCone

## ◆ getDirection()

Vector3f sf::SoundSource::getDirection | ( |  | ) | const
| nodiscardinherited

Get the 3D direction of the sound in the audio scene.

Returns
  Direction of the sound

See also
  setDirection

## ◆ getDirectionalAttenuationFactor()

float sf::SoundSource::getDirectionalAttenuationFactor | ( |  | ) | const
| nodiscardinherited

Get the directional attenuation factor of the sound.

Returns
  Directional attenuation factor of the sound

See also
  setDirectionalAttenuationFactor

## ◆ getDopplerFactor()

float sf::SoundSource::getDopplerFactor | ( |  | ) | const
| nodiscardinherited

Get the doppler factor of the sound.

Returns
  Doppler factor of the sound

See also
  setDopplerFactor

## ◆ getDuration()

Time sf::Music::getDuration | ( |  | ) | const
| nodiscard

Get the total duration of the music.

Returns
  Music duration

## ◆ getLoopPoints()

TimeSpan sf::Music::getLoopPoints | ( |  | ) | const
| nodiscard

Get the positions of the of the sound's looping sequence.

Returns
  Loop Time position class.

Warning
  Since setLoopPoints() performs some adjustments on the provided values and rounds them to internal samples, a call to getLoopPoints() is not guaranteed to return the same times passed into a previous call to setLoopPoints(). However, it is guaranteed to return times that will map to the valid internal samples of this Music if they are later passed to setLoopPoints().

See also
  setLoopPoints

## ◆ getMaxDistance()

float sf::SoundSource::getMaxDistance | ( |  | ) | const
| nodiscardinherited

Get the maximum distance of the sound.

Returns
  Maximum distance of the sound

See also
  setMaxDistance, getAttenuation

## ◆ getMaxGain()

float sf::SoundSource::getMaxGain | ( |  | ) | const
| nodiscardinherited

Get the maximum gain of the sound.

Returns
  Maximum gain of the sound

See also
  setMaxGain, getAttenuation

## ◆ getMinDistance()

float sf::SoundSource::getMinDistance | ( |  | ) | const
| nodiscardinherited

Get the minimum distance of the sound.

Returns
  Minimum distance of the sound

See also
  setMinDistance, getAttenuation

## ◆ getMinGain()

float sf::SoundSource::getMinGain | ( |  | ) | const
| nodiscardinherited

Get the minimum gain of the sound.

Returns
  Minimum gain of the sound

See also
  setMinGain, getAttenuation

## ◆ getPan()

float sf::SoundSource::getPan | ( |  | ) | const
| nodiscardinherited

Get the pan of the sound.

Returns
  Pan of the sound

See also
  setPan

## ◆ getPitch()

float sf::SoundSource::getPitch | ( |  | ) | const
| nodiscardinherited

Get the pitch of the sound.

Returns
  Pitch of the sound

See also
  setPitch

## ◆ getPlayingOffset()

Time sf::SoundStream::getPlayingOffset | ( |  | ) | const
| nodiscardinherited

Get the current playing position of the stream.

Returns
  Current playing position, from the beginning of the stream

See also
  setPlayingOffset

## ◆ getPosition()

Vector3f sf::SoundSource::getPosition | ( |  | ) | const
| nodiscardinherited

Get the 3D position of the sound in the audio scene.

Returns
  Position of the sound

See also
  setPosition

## ◆ getSampleRate()

unsigned int sf::SoundStream::getSampleRate | ( |  | ) | const
| nodiscardinherited

Get the stream sample rate of the stream.

The sample rate is the number of audio samples played per second. The higher, the better the quality.

Returns
  Sample rate, in number of samples per second

## ◆ getStatus()

Status sf::SoundStream::getStatus | ( |  | ) | const
| nodiscardoverridevirtualinherited

Get the current status of the stream (stopped, paused, playing).

Returns
  Current status

Implements sf::SoundSource.

## ◆ getVelocity()

Vector3f sf::SoundSource::getVelocity | ( |  | ) | const
| nodiscardinherited

Get the 3D velocity of the sound in the audio scene.

Returns
  Velocity of the sound

See also
  setVelocity

## ◆ getVolume()

float sf::SoundSource::getVolume | ( |  | ) | const
| nodiscardinherited

Get the volume of the sound.

Returns
  Volume of the sound, in the range [0, 100]

See also
  setVolume

## ◆ initialize()

void sf::SoundStream::initialize | ( | unsigned int | channelCount,
|  | unsigned int | sampleRate,
|  | const std::vector< SoundChannel > & | channelMap )
| protectedinherited

Define the audio stream parameters.

This function must be called by derived classes as soon as they know the audio settings of the stream to play. Any attempt to manipulate the stream (play(), ...) before calling this function will fail. It can be called multiple times if the settings of the audio stream change, but only when the stream is stopped.

Parameters

  channelCount | Number of channels of the stream
  sampleRate | Sample rate, in samples per second
  channelMap | Map of position in sample frame to sound channel

## ◆ isLooping()

bool sf::SoundStream::isLooping | ( |  | ) | const
| nodiscardinherited

Tell whether or not the stream is in loop mode.

Returns
  true if the stream is looping, false otherwise

See also
  setLooping

## ◆ isRelativeToListener()

bool sf::SoundSource::isRelativeToListener | ( |  | ) | const
| nodiscardinherited

Tell whether the sound's position is relative to the listener or is absolute.

Returns
  true if the position is relative, false if it's absolute

See also
  setRelativeToListener

## ◆ isSpatializationEnabled()

bool sf::SoundSource::isSpatializationEnabled | ( |  | ) | const
| nodiscardinherited

Tell whether spatialization of the sound is enabled.

Returns
  true if spatialization is enabled, false if it's disabled

See also
  setSpatializationEnabled

## ◆ onGetData()

bool sf::Music::onGetData | ( | Chunk & | data | ) |
| nodiscardoverrideprotectedvirtual

Request a new chunk of audio samples from the stream source.

This function fills the chunk from the next samples to read from the audio file.

Parameters

  data | Chunk of data to fill

Returns
  true to continue playback, false to stop

Implements sf::SoundStream.

## ◆ onLoop()

std::optional< std::uint64_t > sf::Music::onLoop | ( |  | ) |
| overrideprotectedvirtual

Change the current playing position in the stream source to the loop offset.

This is called by the underlying SoundStream whenever it needs us to reset the seek position for a loop. We then determine whether we are looping on a loop point or the end-of-file, perform the seek, and return the new position.

Returns
  The seek position after looping (or std::nullopt if there's no loop)

Reimplemented from sf::SoundStream.

## ◆ onSeek()

void sf::Music::onSeek | ( | Time | timeOffset | ) |
| overrideprotectedvirtual

Change the current playing position in the stream source.

Parameters

  timeOffset | New playing position, from the beginning of the music

Implements sf::SoundStream.

## ◆ openFromFile()

bool sf::Music::openFromFile | ( | const std::filesystem::path & | filename | ) |
| nodiscard

Open a music from an audio file.

This function doesn't start playing the music (call play() to do so). See the documentation of sf::InputSoundFile for the list of supported formats.

Warning
  Since the music is not loaded at once but rather streamed continuously, the file must remain accessible until the sf::Music object loads a new music or is destroyed.

Parameters

  filename | Path of the music file to open

Returns
  true if loading succeeded, false if it failed

See also
  openFromMemory, openFromStream

## ◆ openFromMemory()

bool sf::Music::openFromMemory | ( | const void * | data,
|  | std::size_t | sizeInBytes )
| nodiscard

Open a music from an audio file in memory.

This function doesn't start playing the music (call play() to do so). See the documentation of sf::InputSoundFile for the list of supported formats.

Warning
  Since the music is not loaded at once but rather streamed continuously, the data buffer must remain accessible until the sf::Music object loads a new music or is destroyed. That is, you can't deallocate the buffer right after calling this function.

Parameters

  data | Pointer to the file data in memory
  sizeInBytes | Size of the data to load, in bytes

Returns
  true if loading succeeded, false if it failed

See also
  openFromFile, openFromStream

## ◆ openFromStream()

bool sf::Music::openFromStream | ( | InputStream & | stream | ) |
| nodiscard

Open a music from an audio file in a custom stream.

This function doesn't start playing the music (call play() to do so). See the documentation of sf::InputSoundFile for the list of supported formats.

Warning
  Since the music is not loaded at once but rather streamed continuously, the stream must remain accessible until the sf::Music object loads a new music or is destroyed.

Parameters

  stream | Source stream to read from

Returns
  true if loading succeeded, false if it failed

See also
  openFromFile, openFromMemory

## ◆ operator=()

Music & sf::Music::operator= | ( | Music && |  | ) |
| noexcept

Move assignment.

## ◆ pause()

void sf::SoundStream::pause | ( |  | ) |
| overridevirtualinherited

Pause the audio stream.

This function pauses the stream if it was playing, otherwise (stream already paused or stopped) it has no effect.

See also
  play, stop

Implements sf::SoundSource.

## ◆ play()

void sf::SoundStream::play | ( |  | ) |
| overridevirtualinherited

Start or resume playing the audio stream.

This function starts the stream if it was stopped, resumes it if it was paused, and restarts it from the beginning if it was already playing. This function uses its own thread so that it doesn't block the rest of the program while the stream is played.

See also
  pause, stop

Implements sf::SoundSource.

## ◆ setAttenuation()

void sf::SoundSource::setAttenuation | ( | float | attenuation | ) |
| inherited

Set the attenuation factor of the sound.

The attenuation is a multiplicative factor which makes the sound more or less loud according to its distance from the listener. An attenuation of 0 will produce a non-attenuated sound, i.e. its volume will always be the same whether it is heard from near or from far. On the other hand, an attenuation value such as 100 will make the sound fade out very quickly as it gets further from the listener. The default value of the attenuation is 1.

Parameters

  attenuation | New attenuation factor of the sound

See also
  getAttenuation, setMinDistance

## ◆ setCone()

void sf::SoundSource::setCone | ( | const Cone & | cone | ) |
| inherited

Set the cone properties of the sound in the audio scene.

The cone defines how directional attenuation is applied. The default cone of a sound is (2 * PI, 2 * PI, 1).

Parameters

  cone | Cone properties of the sound in the scene

See also
  getCone

## ◆ setDirection()

void sf::SoundSource::setDirection | ( | const Vector3f & | direction | ) |
| inherited

Set the 3D direction of the sound in the audio scene.

The direction defines where the sound source is facing in 3D space. It will affect how the sound is attenuated if facing away from the listener. The default direction of a sound is (0, 0, -1).

Parameters

  direction | Direction of the sound in the scene

See also
  getDirection

## ◆ setDirectionalAttenuationFactor()

void sf::SoundSource::setDirectionalAttenuationFactor | ( | float | factor | ) |
| inherited

Set the directional attenuation factor of the sound.

Depending on the virtual position of an output channel relative to the listener (such as in surround sound setups), sounds will be attenuated when emitting them from certain channels. This factor determines how strong the attenuation based on output channel position relative to the listener is.

Parameters

  factor | New directional attenuation factor to apply to the sound

See also
  getDirectionalAttenuationFactor

## ◆ setDopplerFactor()

void sf::SoundSource::setDopplerFactor | ( | float | factor | ) |
| inherited

Set the doppler factor of the sound.

The doppler factor determines how strong the doppler shift will be.

Parameters

  factor | New doppler factor to apply to the sound

See also
  getDopplerFactor

## ◆ setEffectProcessor()

void sf::SoundStream::setEffectProcessor | ( | EffectProcessor | effectProcessor | ) |
| overridevirtualinherited

Set the effect processor to be applied to the sound.

The effect processor is a callable that will be called with sound data to be processed.

Parameters

  effectProcessor | The effect processor to attach to this sound, attach an empty processor to disable processing

Reimplemented from sf::SoundSource.

## ◆ setLooping()

void sf::SoundStream::setLooping | ( | bool | loop | ) |
| inherited

Set whether or not the stream should loop after reaching the end.

If set, the stream will restart from beginning after reaching the end and so on, until it is stopped or setLooping(false) is called. The default looping state for streams is false.

Parameters

  loop | true to play in loop, false to play once

See also
  isLooping

## ◆ setLoopPoints()

void sf::Music::setLoopPoints | ( | TimeSpan | timePoints | ) |

Sets the beginning and duration of the sound's looping sequence using sf::Time.

setLoopPoints() allows for specifying the beginning offset and the duration of the loop such that, when the music is enabled for looping, it will seamlessly seek to the beginning whenever it encounters the end of the duration. Valid ranges for timePoints.offset and timePoints.length are [0, Dur) and (0, Dur-offset] respectively, where Dur is the value returned by getDuration(). Note that the EOF "loop point" from the end to the beginning of the stream is still honored, in case the caller seeks to a point after the end of the loop range. This function can be safely called at any point after a stream is opened, and will be applied to a playing sound without affecting the current playing offset.

Warning
  Setting the loop points while the stream's status is Paused will set its status to Stopped. The playing offset will be unaffected.

Parameters

  timePoints | The definition of the loop. Can be any time points within the sound's length

See also
  getLoopPoints

## ◆ setMaxDistance()

void sf::SoundSource::setMaxDistance | ( | float | distance | ) |
| inherited

Set the maximum distance of the sound.

The "maximum distance" of a sound is the minimum distance at which it is heard at its minimum volume. Closer than the maximum distance, it will start to fade in according to its attenuation factor. The default value of the maximum distance is the maximum value a float can represent.

Parameters

  distance | New maximum distance of the sound

See also
  getMaxDistance, setAttenuation

## ◆ setMaxGain()

void sf::SoundSource::setMaxGain | ( | float | gain | ) |
| inherited

Set the maximum gain of the sound.

When the sound is closer from the listener than the "minimum distance" the attenuated gain is clamped so it cannot go above the maximum gain value.

Parameters

  gain | New maximum gain of the sound

See also
  getMaxGain, setAttenuation

## ◆ setMinDistance()

void sf::SoundSource::setMinDistance | ( | float | distance | ) |
| inherited

Set the minimum distance of the sound.

The "minimum distance" of a sound is the maximum distance at which it is heard at its maximum volume. Further than the minimum distance, it will start to fade out according to its attenuation factor. A value of 0 ("inside the head of the listener") is an invalid value and is forbidden. The default value of the minimum distance is 1.

Parameters

  distance | New minimum distance of the sound

See also
  getMinDistance, setAttenuation

## ◆ setMinGain()

void sf::SoundSource::setMinGain | ( | float | gain | ) |
| inherited

Set the minimum gain of the sound.

When the sound is further away from the listener than the "maximum distance" the attenuated gain is clamped so it cannot go below the minimum gain value.

Parameters

  gain | New minimum gain of the sound

See also
  getMinGain, setAttenuation

## ◆ setPan()

void sf::SoundSource::setPan | ( | float | pan | ) |
| inherited

Set the pan of the sound.

Using panning, a mono sound can be panned between stereo channels. When the pan is set to -1, the sound is played only on the left channel, when the pan is set to +1, the sound is played only on the right channel.

Parameters

  pan | New pan to apply to the sound [-1, +1]

See also
  getPan

## ◆ setPitch()

void sf::SoundSource::setPitch | ( | float | pitch | ) |
| inherited

Set the pitch of the sound.

The pitch represents the perceived fundamental frequency of a sound; thus you can make a sound more acute or grave by changing its pitch. A side effect of changing the pitch is to modify the playing speed of the sound as well. The default value for the pitch is 1.

Parameters

  pitch | New pitch to apply to the sound

See also
  getPitch

## ◆ setPlayingOffset()

void sf::SoundStream::setPlayingOffset | ( | Time | timeOffset | ) |
| inherited

Change the current playing position of the stream.

The playing position can be changed when the stream is either paused or playing. Changing the playing position when the stream is stopped has no effect, since playing the stream would reset its position.

Parameters

  timeOffset | New playing position, from the beginning of the stream

See also
  getPlayingOffset

## ◆ setPosition()

void sf::SoundSource::setPosition | ( | const Vector3f & | position | ) |
| inherited

Set the 3D position of the sound in the audio scene.

Only sounds with one channel (mono sounds) can be spatialized. The default position of a sound is (0, 0, 0).

Parameters

  position | Position of the sound in the scene

See also
  getPosition

## ◆ setRelativeToListener()

void sf::SoundSource::setRelativeToListener | ( | bool | relative | ) |
| inherited

Make the sound's position relative to the listener or absolute.

Making a sound relative to the listener will ensure that it will always be played the same way regardless of the position of the listener. This can be useful for non-spatialized sounds, sounds that are produced by the listener, or sounds attached to it. The default value is false (position is absolute).

Parameters

  relative | true to set the position relative, false to set it absolute

See also
  isRelativeToListener

## ◆ setSpatializationEnabled()

void sf::SoundSource::setSpatializationEnabled | ( | bool | enabled | ) |
| inherited

Set whether spatialization of the sound is enabled.

Spatialization is the application of various effects to simulate a sound being emitted at a virtual position in 3D space and exhibiting various physical phenomena such as directional attenuation and doppler shift.

Parameters

  enabled | true to enable spatialization, false to disable

See also
  isSpatializationEnabled

## ◆ setVelocity()

void sf::SoundSource::setVelocity | ( | const Vector3f & | velocity | ) |
| inherited

Set the 3D velocity of the sound in the audio scene.

The velocity is used to determine how to doppler shift the sound. Sounds moving towards the listener will be perceived to have a higher pitch and sounds moving away from the listener will be perceived to have a lower pitch.

Parameters

  velocity | Velocity of the sound in the scene

See also
  getVelocity

## ◆ setVolume()

void sf::SoundSource::setVolume | ( | float | volume | ) |
| inherited

Set the volume of the sound.

The volume is a value between 0 (mute) and 100 (full volume). The default value for the volume is 100.

Parameters

  volume | Volume of the sound

See also
  getVolume

## ◆ stop()

void sf::SoundStream::stop | ( |  | ) |
| overridevirtualinherited

Stop playing the audio stream.

This function stops the stream if it was playing or paused, and does nothing if it was already stopped. It also resets the playing position (unlike pause()).

See also
  play, pause

Implements sf::SoundSource.

The documentation for this class was generated from the following file:

- Music.hpp